package com.zanxiang.sdk.service.Impl;

import com.zanxiang.common.domain.ResultMap;
import com.zanxiang.common.utils.SpringUtils;
import com.zanxiang.sdk.domain.bo.ProductPayParamBO;
import com.zanxiang.sdk.enums.PayTypeEnum;
import com.zanxiang.sdk.service.GamePayWayService;
import com.zanxiang.sdk.service.OrderPayService;
import com.zanxiang.sdk.service.PlatformOrderService;
import com.zanxiang.sdk.service.pay.PayBaseService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

/**
 * @author : lingfeng
 * @time : 2022-09-28
 * @description : 订单支付
 */
@Slf4j
@Service
public class OrderPayServiceImpl implements OrderPayService {

    @Autowired
    public PlatformOrderService platformOrderService;

    @Autowired
    public GamePayWayService gamePayWayService;

    @Override
    public ResultMap payCreate(ProductPayParamBO product) {
        PayTypeEnum payTypeEnum = PayTypeEnum.getByPayType(product.getPayWay());
        PayBaseService service = SpringUtils.getBean(payTypeEnum.getClazz());
        return service.payCreate(product);
    }

    @Override
    public String notify(HttpServletRequest request, HttpServletResponse response, Integer payType) throws IOException {
        PayTypeEnum payTypeEnum = PayTypeEnum.getByPayType(payType);
        PayBaseService service = SpringUtils.getBean(payTypeEnum.getClazz());
        return service.notify(request, response);
    }

    @Override
    public ResultMap synNotify(HttpServletRequest request, Integer payType) {
        PayTypeEnum payTypeEnum = PayTypeEnum.getByPayType(payType);
        PayBaseService service = SpringUtils.getBean(payTypeEnum.getClazz());
        return service.synNotify(request);
    }
}
